pipeline {
    agent any
    stages {
        
         stage('slack notification before deployment') {
            steps {
           slackSend iconEmoji: '', message: 'slack notification', tokenCredentialId: 'neeraj', username: ''
            }
       }
        
        stage('git clone') {
            steps {
                sh 'rm -rf spring3hibernate' ; sh 'git clone https://github.com/neerajops/spring3hibernate.git'
            }
        }
         stage('email notification') {
            steps {
           emailext body: '', subject: 'going to deploy start deploy', to: 'neeraj.chaurasia@mygurukulam.org'
            }
         }
       stage('proceed or abort') {
            steps {
            input message: 'do you want to proceed?', ok: 'yes', submitter: 'admin,neeraj chaurasia'
            }
       }
     stage('code stability') {
            steps {
        sh 'cd spring3hibernate ; mvn clean compile'
            }
     }
    stage('static code analysis') {
            steps {
            sh 'cd spring3hibernate ; mvn findbugs:findbugs'
           
            }
     }
     
      stage(' Static Code Analysis') {
            steps {
           sh 'cd spring3hibernate ; mvn checkstyle:checkstyle' 
            }
       }
        
   stage('code coverage') {
            steps {
        sh 'cd spring3hibernate ; mvn cobertura:cobertura'
            }
     }
    
         stage ('Publish Cobertura checkstyle findbugs ')
       {
           steps {
               cobertura autoUpdateHealth: false, autoUpdateStability: false, coberturaReportFile: '**/target/site/cobertura/coverage.xml', conditionalCoverageTargets: '70, 0, 0', failUnhealthy: false, failUnstable: false, lineCoverageTargets: '80, 0, 0', maxNumberOfBuilds: 0, methodCoverageTargets: '80, 0, 0', onlyStable: false, sourceEncoding: 'ASCII', zoomCoverageChart: false
           checkstyle canComputeNew: false, defaultEncoding: '', healthy: '', pattern: '**/checkstyle-result.xml', unHealthy: ''
               findbugs canComputeNew: false, defaultEncoding: '', excludePattern: '', healthy: '', includePattern: '', pattern: '', unHealthy: ''
           }
           
       }
          stage ('proceed or abort ')
       {
           steps {
input message: 'can do deployment?', ok: 'yes', submitter: 'admin,neeraj chaurasia'
           }
           
       }
        stage ('war file generation')
       {
           steps {
sh 'cd spring3hibernate ; mvn install'
           }
           
       }
    
     stage ('deploy war file in tomcat8')
       {
           steps {
sh 'sudo cp /var/lib/jenkins/.m2/repository/Spring3HibernateApp/Spring3HibernateApp/1.8-SNAPSHOT/Spring3HibernateApp-1.8-SNAPSHOT.war /var/lib/tomcat8/webapps'
           }
           
       }
    stage('slack notification after deployment') {
            steps {
           slackSend iconEmoji: '', message: 'slack notification', tokenCredentialId: 'neeraj', username: ''
            }
       }
        
    }
}
